CMSIS-DSP: Partial Convolution

| CMSIS-DSP Version 1.5.2 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Partial Convolution
Filtering Functions

## Functions
arm_status | arm_conv_partial_f32 (float32_t *pSrcA, uint32_t srcALen, float32_t *pSrcB, uint32_t srcBLen, float32_t *pDst, uint32_t firstIndex, uint32_t numPoints)
| Partial convolution of floating-point sequences. More...
arm_status | arm_conv_partial_fast_opt_q15 (q15_t *pSrcA, uint32_t srcALen, q15_t *pSrcB, uint32_t srcBLen, q15_t *pDst, uint32_t firstIndex, uint32_t numPoints, q15_t *pScratch1, q15_t *pScratch2)
| Partial convolution of Q15 sequences (fast version) for Cortex-M3 and Cortex-M4. More...
arm_status | arm_conv_partial_fast_q15 (q15_t *pSrcA, uint32_t srcALen, q15_t *pSrcB, uint32_t srcBLen, q15_t *pDst, uint32_t firstIndex, uint32_t numPoints)
| Partial convolution of Q15 sequences (fast version) for Cortex-M3 and Cortex-M4. More...
arm_status | arm_conv_partial_fast_q31 (q31_t *pSrcA, uint32_t srcALen, q31_t *pSrcB, uint32_t srcBLen, q31_t *pDst, uint32_t firstIndex, uint32_t numPoints)
| Partial convolution of Q31 sequences (fast version) for Cortex-M3 and Cortex-M4. More...
arm_status | arm_conv_partial_opt_q15 (q15_t *pSrcA, uint32_t srcALen, q15_t *pSrcB, uint32_t srcBLen, q15_t *pDst, uint32_t firstIndex, uint32_t numPoints, q15_t *pScratch1, q15_t *pScratch2)
| Partial convolution of Q15 sequences. More...
arm_status | arm_conv_partial_opt_q7 (q7_t *pSrcA, uint32_t srcALen, q7_t *pSrcB, uint32_t srcBLen, q7_t *pDst, uint32_t firstIndex, uint32_t numPoints, q15_t *pScratch1, q15_t *pScratch2)
| Partial convolution of Q7 sequences. More...
arm_status | arm_conv_partial_q15 (q15_t *pSrcA, uint32_t srcALen, q15_t *pSrcB, uint32_t srcBLen, q15_t *pDst, uint32_t firstIndex, uint32_t numPoints)
| Partial convolution of Q15 sequences. More...
arm_status | arm_conv_partial_q31 (q31_t *pSrcA, uint32_t srcALen, q31_t *pSrcB, uint32_t srcBLen, q31_t *pDst, uint32_t firstIndex, uint32_t numPoints)
| Partial convolution of Q31 sequences. More...
arm_status | arm_conv_partial_q7 (q7_t *pSrcA, uint32_t srcALen, q7_t *pSrcB, uint32_t srcBLen, q7_t *pDst, uint32_t firstIndex, uint32_t numPoints)
| Partial convolution of Q7 sequences. More...

## Description

Partial Convolution is equivalent to Convolution except that a subset of the output samples is generated. Each function has two additional arguments. `firstIndex` specifies the starting index of the subset of output samples. `numPoints` is the number of output samples to compute. The function computes the output in the range `[firstIndex, ..., firstIndex+numPoints-1]`. The output array `pDst` contains `numPoints` values.

The allowable range of output indices is [0 srcALen+srcBLen-2]. If the requested subset does not fall in this range then the functions return ARM_MATH_ARGUMENT_ERROR. Otherwise the functions return ARM_MATH_SUCCESS.

Note
  Refer arm_conv_f32() for details on fixed point behavior.

Fast Versions

  Fast versions are supported for Q31 and Q15 of partial convolution. Cycles for Fast versions are less compared to Q31 and Q15 of partial conv and the design requires the input signals should be scaled down to avoid intermediate overflows.

Opt Versions

  Opt versions are supported for Q15 and Q7. Design uses internal scratch buffer for getting good optimisation. These versions are optimised in cycles and consumes more memory(Scratch memory) compared to Q15 and Q7 versions of partial convolution

## Function Documentation

arm_status arm_conv_partial_f32 | ( | float32_t * | pSrcA,
|  | uint32_t | srcALen,
|  | float32_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | float32_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

References ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.

arm_status arm_conv_partial_fast_opt_q15 | ( | q15_t * | pSrcA,
|  | uint32_t | srcALen,
|  | q15_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | q15_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints,
|  | q15_t * | pScratch1,
|  | q15_t * | pScratch2
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.
  [in] | *pScratch1 | points to scratch buffer of size max(srcALen, srcBLen) + 2*min(srcALen, srcBLen) - 2.
  [in] | *pScratch2 | points to scratch buffer of size min(srcALen, srcBLen).

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

See `arm_conv_partial_q15()` for a slower implementation of this function which uses a 64-bit accumulator to avoid wrap around distortion.

Restrictions
  If the silicon does not support unaligned memory access enable the macro UNALIGNED_SUPPORT_DISABLE In this case input, output, scratch1 and scratch2 buffers should be aligned by 32-bit

References __PKHBT, __SIMD32, __SMLAD(), __SMLADX(), _SIMD32_OFFSET, arm_copy_q15(), arm_fill_q15(), ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.

arm_status arm_conv_partial_fast_q15 | ( | q15_t * | pSrcA,
|  | uint32_t | srcALen,
|  | q15_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | q15_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

See `arm_conv_partial_q15()` for a slower implementation of this function which uses a 64-bit accumulator to avoid wrap around distortion.

References __PKHBT, __SIMD32, __SMLAD(), __SMLADX(), _SIMD32_OFFSET, ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.

arm_status arm_conv_partial_fast_q31 | ( | q31_t * | pSrcA,
|  | uint32_t | srcALen,
|  | q31_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | q31_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

  See `arm_conv_partial_q31()` for a slower implementation of this function which uses a 64-bit accumulator to provide higher precision.

References ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.

arm_status arm_conv_partial_opt_q15 | ( | q15_t * | pSrcA,
|  | uint32_t | srcALen,
|  | q15_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | q15_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints,
|  | q15_t * | pScratch1,
|  | q15_t * | pScratch2
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.
  [in] | *pScratch1 | points to scratch buffer of size max(srcALen, srcBLen) + 2*min(srcALen, srcBLen) - 2.
  [in] | *pScratch2 | points to scratch buffer of size min(srcALen, srcBLen).

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

Restrictions
  If the silicon does not support unaligned memory access enable the macro UNALIGNED_SUPPORT_DISABLE In this case input, output, state buffers should be aligned by 32-bit

Refer to `arm_conv_partial_fast_q15()` for a faster but less precise version of this function for Cortex-M3 and Cortex-M4.

References __PKHBT, __SIMD32, __SMLALD(), __SMLALDX(), _SIMD32_OFFSET, arm_copy_q15(), arm_fill_q15(), ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.

arm_status arm_conv_partial_opt_q7 | ( | q7_t * | pSrcA,
|  | uint32_t | srcALen,
|  | q7_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | q7_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints,
|  | q15_t * | pScratch1,
|  | q15_t * | pScratch2
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.
  [in] | *pScratch1 | points to scratch buffer(of type q15_t) of size max(srcALen, srcBLen) + 2*min(srcALen, srcBLen) - 2.
  [in] | *pScratch2 | points to scratch buffer (of type q15_t) of size min(srcALen, srcBLen).

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

Restrictions
  If the silicon does not support unaligned memory access enable the macro UNALIGNED_SUPPORT_DISABLE In this case input, output, scratch1 and scratch2 buffers should be aligned by 32-bit

References __PACKq7, __PKHBT, __SIMD32, __SMLAD(), __SMLADX(), _SIMD32_OFFSET, arm_fill_q15(), ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.

arm_status arm_conv_partial_q15 | ( | q15_t * | pSrcA,
|  | uint32_t | srcALen,
|  | q15_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | q15_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

Refer to `arm_conv_partial_fast_q15()` for a faster but less precise version of this function for Cortex-M3 and Cortex-M4.

  Refer the function `arm_conv_partial_opt_q15()` for a faster implementation of this function using scratch buffers.

References __PKHBT, __SIMD32, __SMLALD(), __SMLALDX(), _SIMD32_OFFSET, ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.

arm_status arm_conv_partial_q31 | ( | q31_t * | pSrcA,
|  | uint32_t | srcALen,
|  | q31_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | q31_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

See `arm_conv_partial_fast_q31()` for a faster but less precise implementation of this function for Cortex-M3 and Cortex-M4.

References ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.

arm_status arm_conv_partial_q7 | ( | q7_t * | pSrcA,
|  | uint32_t | srcALen,
|  | q7_t * | pSrcB,
|  | uint32_t | srcBLen,
|  | q7_t * | pDst,
|  | uint32_t | firstIndex,
|  | uint32_t | numPoints
| ) |  |

Parameters

  [in] | *pSrcA | points to the first input sequence.
  [in] | srcALen | length of the first input sequence.
  [in] | *pSrcB | points to the second input sequence.
  [in] | srcBLen | length of the second input sequence.
  [out] | *pDst | points to the location where the output result is written.
  [in] | firstIndex | is the first output sample to start with.
  [in] | numPoints | is the number of output points to be computed.

Returns
  Returns either ARM_MATH_SUCCESS if the function completed correctly or ARM_MATH_ARGUMENT_ERROR if the requested subset is not in the range [0 srcALen+srcBLen-2].

  Refer the function `arm_conv_partial_opt_q7()` for a faster implementation of this function.

References __SMLAD(), ARM_MATH_ARGUMENT_ERROR, ARM_MATH_SUCCESS, srcALen, srcBLen, and status.